option(USE_PVS_STUDIO "Use PVS-Studio for static analysis" OFF)

if(USE_PVS_STUDIO)
  include(PVS-Studio)
  find_program(PVS_STUDIO_ANALYZER_EXE NAMES pvs-studio-analyzer)
  if(PVS_STUDIO_ANALYZER_EXE AND NOT TARGET pvs-global-checker)
    pvs_studio_add_target(TARGET pvs-global-checker
      ALL
      RECURSIVE
      HIDE_HELP
      COMPILE_COMMANDS
      OUTPUT FORMAT errorfile
      MODE GA:1,2,3;64:1;OP:1,2;CS:1,2
      LOG target.err)
  else()
    message(WARNING "PVS-Studio is not found")
  endif()
endif()

